// FILENAME:  MercsIncEarthA.cs
//
// AUTHORS:    Orogogus
//------------------------------------------------------------------------------

exec("MercsInc_LobbyStdLib.cs");
$MImaxMissions = 7;       // Server ops should set according to preference
$MIcurrentLobby = "MercsIncEarthA";

for(%i=0; %i<$MImaxMissions; %i++) $MImission[%i] = "";
exec("MercsIncMissionListEarthA.cs");


//===============


function Mercs::inscribeMissions()
{
  $MIplaceHolder = "Mercenaries, Inc. Mission List -- Earth A";
  export("$MIplaceHolder", "multiplayer\\MercsIncMissionListEarthA.cs", overwrite);
  fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionCount = " @ $MImissionCount @ ";");
  fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MItotalMissions = " @ $MItotalMissions @ ";");
  fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "");

  for(%i=0; %i<$MImissionCount; %i++)
  {
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImission[" @ %i @ "] = \"" @ $MImission[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionBountyPercent[" @ %i @ "] = " @ $MImissionBountyPercent[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionDate[" @ %i @ "] = \"" @ $MImissionDate[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionDifficulty[" @ %i @ "] = " @ $MImissionDifficulty[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionLocation[" @ %i @ "] = \"" @ $MImissionLocation[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionNumber[" @ %i @ "] = " @ $MImissionNumber[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionParameters[" @ %i @ "] = " @ $MImissionParameters[%i] @ ";");

    for(%j=0; %j<$MImissionParameters[%i]; %j++)
    {
      fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionParameter[" @ %i @ ", " @ %j @ "] = " @ $MImissionParameter[%i, %j] @ ";");
    }

    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionPay[" @ %i @ "] = " @ $MImissionPay[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionTime[" @ %i @ "] = \"" @ $MImissionTime[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionTransportPercent[" @ %i @ "] = " @ $MImissionTransportPercent[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "$MImissionType[" @ %i @ "] = \"" @ $MImissionType[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncMissionListEarthA.cs" , append, "" );
  }
}


function Mercs::makeMission(%missionNum)
{
//  Date and time format looks like this: 07/04/00, 00:08:49

  exec("MercsIncMissionTemplateEarthA.cs");

  %newMission = randomInt(0, (%MImisTemplates - 1) );          // Pick a mission from the mission template
  $MImission[%missionNum] = %MImisTemplate[%newMission];       // Step 1 in creating the new mission
  $MImissionType[%missionNum] = %MImisTemplateType[%newMission];
  $MImissionLocation[%missionNum] = %MImisTemplateLocation[%newMission];
  $MImissionParameters[%missionNum] = %MImisTemplateParameters[%newMission];
  $MImissionDate[%missionNum] = getDate();
  $MImissionTime[%missionNum] = getTime();

  $MItotalMissions++;
  $MImissionNumber[%missionNum] = $MItotalMissions;

  %difficulty = 0;
  for(%i=0; %i<%MImisTemplateParameters[%newMission]; %i++)
  {
    %parameter[%missionNum, %i] = randomInt(%MImisTemplateParameterMin[%newMission, %i], %MImisTemplateParameterMax[%newMission, %i]);
    $MImissionParameter[%missionNum, %i] = %parameter[%missionNum, %i];
    %difficulty = %difficulty + %parameter[%missionNum, %i];
  }
  %difficulty = %difficulty / %MImisTemplateParameters[%newMission];
  %difficulty = Mercs::round(%difficulty);
  $MImissionDifficulty[%missionNum] = %difficulty;
  %difficultyMultiplier = %difficulty / %MImisTemplateAvgDifficulty[%newMission];

  $MImissionPay[%missionNum] = Mercs::round(%MImisTemplateBasePay[%newMission] * %difficultyMultiplier * Mercs::statRoll(20, 6));
  $MImissionTransportPercent[%missionNum] = Mercs::round(%MImisTemplateBaseTransportPercent[%newMission] * Mercs::statRoll(20, 6));
  $MImissionBountyPercent[%missionNum] = Mercs::round(%MImisTemplateBaseBountyPercent[%newMission] * %difficultyMultiplier * Mercs::statRoll(20, 6));

  Mercs::inscribeMissions();
}


//===============


Mercs::fillMissionList();
