// FILENAME:  MercsInc_LobbyStdLib.cs
//
// AUTHORS:    Orogogus
//------------------------------------------------------------------------------

$missionName = "Mercenaries, Inc. v0.1.1";
$server::TeamDamage = false;
exec("MercsIncMultiplayerStdLib.cs");
exec("MIConfigCosts.cs");
exec("MIPlayerClone.cs");
exec("MercsIncPlayerList.cs");
$MIcurrentMission = -1;
$MIreadyToLaunch = 0;     // 0: no mission selected; 1: not all players logged in; 2: mission launched

for(%i=0; %i<$MImaxMissions; %i++) $MImission[%i] = "";
for(%i = 0; %i<10000; %i++) if(getObjectName(%i) == "AIVehicle") deleteObject(%i);


function onMissionLoad()
{
  $MIDronefarm = getObjectID("MissionGroup\\dronefarm");
  $MIbioderm = getObjectID("MissionGroup\\bioderms");
  $MIDronefarm.counter = -1;
  $MIbioderm.counter = 0;
  $MIbioderm.multiplier = 0.5;
  $MIbioderm.currentDerm = "L1 Bioderm";
}


function setDefaultMissionOptions()
{
  $server::TeamPlay = true;
  $server::AllowDeathmatch = false;
  $server::AllowTeamPlay = true;  

   // what can the client choose for a team
  $server::AllowTeamRed = false;
  $server::AllowTeamBlue = true;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = false;	

  // what can the server admin choose for available teams
  $server::disableTeamRed = true;
  $server::disableTeamBlue = false;
  $server::disableTeamYellow = true;
  $server::disableTeamPurple = true;
}


function player::OnAdd(%player)
{
  if(%player == 0) return;
  %vehicle = playerManager::playerNumToVehicleID(%player);
  %player.MIloggedIn = 0;
  %player.MIstartMission = 0;
  messagebox(%player, "Welcome to Mercenaries, Inc., a Starsiege script under testing.  If this is your first time on the server, please go to http://home.san.rr.com/orogogus/MercsInc for instructions.");
}


function player::onRemove(%player)
{
  %count = playerManager::getPlayerCount();
  if(%count == 0) 
  {
    $MissionCycling::Stage0 = $MICurrentLobby;
    $MIcurrentMission = -1;
    $MIreadyToLaunch = 0; 
  }
  if($MIreadyToLaunch == 0) return;
  else Mercs::startCheck3(%player);
}


function vehicle::OnAdd(%vehicle)
{
  %player = playerManager::VehicleIdToPlayerNum(%vehicle);
  if(%player == 0) return;
  %player.MIstartMission = 0;
  setTeam(%vehicle, *IDSTR_TEAM_RED);
  %vehicleCost = MIConfigCosts::checkvalue(%vehicle);
  say(%player, 0, "Welcome to Mercenaries, Inc.  Reminder: if you're confused, the webpage for Mercenaries Inc. is http://home.san.rr.com/orogogus/MercsInc/");
  say(%player, 0, "Your vehicle cost is $" @ %vehicleCost @ ".");
}


//======================================


function Mercs::checkPlayerName(%player, %password)
{

  %nameMatch = 0;

  for(%i=0; %i<$MIPlayers; %i++)
  {
    if(getName(%player) == $MIPlayer[%i])
    {
      %nameMatch = 1;

      if(%password != $MIPlayerPassword[%i])
      {
        messagebox(%player, "Sorry, your password doesn't match your name! " @ 
          "Either someone has already registered this name " @
          "or your password is incorrectly configured.  " @ 
          "Please report on the Editing and Scripting board.  Thank you, and enjoy your visit.");
      }
      else
      {
        %player.MImoney = $MIPlayerMoney[%i];
        %player.MIloggedIn = 1;
        %player.MIid = %i;
        %player.MIDrones = $MIPlayerDrones[%i];

        for(%j=0; %j<%player.MIdrones; %j++)
        {
          %player.MIdroneFile[%j] = $MIPlayerDroneFile[%i, %j];
          %player.MIdroneDescription[%j] = $MIPlayerDroneDescription[%i, %j];
          %player.MIdroneCost[%j] = $MIPlayerDroneCost[%i, %j];
          %player.MIdroneBioderm[%j] = $MIPlayerDroneBioderm[%i, %j];
        }

        say(%player, 0, "Welcome back, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");

        for(%j=0; %j<%player.MIdrones; %j++)
        {
           if(%player.MIdroneDescription[%j] == "") say(%player, 0, "Drone " @ %j @ "-- (empty)");
           say(%player, 0, "Drone" @ %j @ "-- " @ %player.MIdroneDescription[%j] @ "(" @ %player.MIdroneBioderm[%j] @ ") -- $" @ %player.MIdroneCost[%j]);
        }

        if($MIreadyToLaunch == 1) Mercs::startCheck2();
      }
    }
  }

  if(%nameMatch == 0)    // sign up a new player
  {
    $MIPlayer[$MIPlayers] = getName(%player);
    $MIPlayerPassword[$MIPlayers] = %password;
    Mercs::inscribeRecord();
    %player.MIid = %i;
    $MIPlayers++;

    messagebox(%player, "Welcome to Mercenaries, Inc.  Please excuse the dust.  Have $80000 for testing purposes.");
    %player.MImoney = 0;
    %player.MIloggedIn = 1;
    %player.MIdrones = 0;
    $MIPlayerDrones[%player.MIid] = %player.MIdrones;
    Mercs::confirmDrones(%player);
    Mercs::addMoney(%player, 80000);

    if($MIreadyToLaunch == 1) Mercs::startCheck2();
  }
}


function Mercs::confirmDrones(%player)
{
  $MIPlayerDrones[%player.MIid] = %player.MIdrones;
  for(%j=0; %j<$MIPlayerdrones[%player.MIid]; %j++)
  {
    $MIPlayerDroneFile[%player.MIid, %j] = %player.MIDroneFile[%j];
    $MIPlayerDroneDescription[%player.MIid, %j] = %player.MIDroneDescription[%j];
    $MIPlayerDroneCost[%player.MIid, %j] = %player.MIDroneCost[%j];
    $MIPlayerDroneBioderm[%player.MIid, %j] = %player.MIDroneBioderm[%j];
  }
  Mercs::InscribePlayers();
}


function Mercs::addMoney(%player, %money)
{
  %player.MImoney = %player.MImoney + %money;
  if(%player.MImoney < 0) %player.MImoney = 0;
  $MIPlayerMoney[%player.MIid] = %player.MImoney;  
  Mercs::InscribePlayers();
}


function Mercs::cleanMissionList()
{
  if($MImissionCount<2 && $MImission[0] == "empty")
  {
    Mercs::makeMission(0);
  }
  else
  {
    for(%i=0; %i<($MImissionCount-1); %i++)
    {
      if($MImission[%i] == "empty")
      {
        %swapped = 0;
        for(%j=(%i+1); %j<$MImissionCount; %j++)
        {
          if($MImission[%j] != "empty" && %swapped == 0)
          {
            %swapped = 1;
            Mercs::swapMissions(%i, %j);
          }
        }
      }
    }
  }
}


function Mercs::fillMissionList()
{
  $MImissionCount = $MImaxMissions;
  for(%i=0; %i<$MImaxMissions; %i++)
  {
    if($MImission[%i] == "empty" || $MImission[%i] == "")
    {
      Mercs::makeMission(%i);
    }
  }
}


function Mercs::inscribePlayers()
{
  $MIplaceHolder = "Mercenaries, Inc. Player List";
  export("$MIplaceHolder", "multiplayer\\MercsIncPlayerList.cs", overwrite);
  fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayers = " @ $MIPlayers @ ";");
  fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "");

  for(%i=0; %i<$MIPlayers; %i++)
  {
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayer[" @ %i @ "] = \"" @ $MIPlayer[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerMoney[" @ %i @ "] = " @ $MIPlayerMoney[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerPassword[" @ %i @ "] = \"" @ $MIPlayerPassword[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerDrones[" @ %i @ "] = " @ $MIPlayerDrones[%i] @ ";");

    for(%j=0; %j<$MIPlayerdrones[%i]; %j++)
    {
      %temp1 = $MIPlayerDroneFile[%i, %j];
      %temp2 = $MIPlayerDroneDescription[%i, %j];
      %temp3 = $MIPlayerDroneCost[%i, %j];
      %temp4 = $MIPlayerDroneBioderm[%i, %j];

      fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerDroneFile[" @ %i @ ", " @ %j  @"] = \"" @ %temp1 @ "\";");
      fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerDroneDescription[" @ %i @ ", " @ %j @ "] = \"" @ %temp2 @ "\";");
      fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerDroneCost[" @ %i @ ", " @ %j @ "] = " @ %temp3 @ ";");
      fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerDroneBioderm[" @ %i @ ", " @ %j @ "] = \"" @ %temp4 @ "\";");
    }
  }
}


function Mercs::inscribeRecord()
{
  Mercs::inscribeMissions();
  Mercs::inscribePlayers();
}


function Mercs::launchMission()
{
  $MIreadyToLaunch = 2;
  say(0, 0, "Selection locked.  Mission launches in 5 seconds.");

  $MImission[$MIcurrentMission] = "empty";
  Mercs::inscribeMissions();

  schedule("missionEndConditionMet();", 5);
}


function Mercs::selectNextMission()
{
  $MIcurrentMission++;
  if($MIcurrentMission >= $MImissionCount) $MIcurrentMission = 0;

  $MissionCycling::Stage0 = $MImission[$MIcurrentMission];

  $MIlocation = $MImissionLocation[$MIcurrentMission];
  $MItype = $MImissionType[$MIcurrentMission];

  %number = $MImissionNumber[$MIcurrentMission];
  %date = $MImissionDate[$MIcurrentMission];
  %Time = $MImissionTime[$MIcurrentMission];

  $MIbountyPercent = $MImissionBountyPercent[$MIcurrentMission];
  $MIdifficulty = $MImissionDifficulty[$MIcurrentMission];  
  $MItransportPercent = $MImissionTransportPercent[$MIcurrentMission];
  $MItotalPay = $MImissionPay[$MIcurrentMission];

  $MImissionParameters = $MImissionParameters[$MIcurrentMission];
  for(%i=0; %i<$MImissionParameters; %i++)  
  {
    $MImissionParameter[%i] = $MImissionParameter[$MIcurrentMission, %i];
  }

  say(0, 0, "Mission #" @ %number @ ", posted " @ %date @ " " @ %time @ " -- " @ $MIlocation @ " (" @ $MItype @ "), difficulty " @ $MIdifficulty @ 
        ".  Total pay: $" @ $MItotalPay @ ", " @ $MIbountyPercent @ "% kill bounty and " @
        $MItransportPercent @ "% transport fees");
}


function Mercs::startCheck(%player)  // when someone sets the mission
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player2 = playerManager::getPlayerNum(%i);
    if(%player2.MIloggedIn != 1)
    {
      %ready = 0;
      say(%player2, 0, "WARNING: Someone has initiated a mission selection, and you are not logged in.  Please log in now if you want to join this mission.");
      %waitingFor++;
    }
  }

  if(%waitingFor != 1) %plural = "s have";
   else %plural = " has";

  if(%ready == 0)
  {
    say(%player, 0, "WARNING: " @ %waitingFor @ " player" @ %plural @ " not logged in yet.  Please confirm that you want to launch this mission anyway.");
  }
  else Mercs::launchMission();
}


function Mercs::startCheck2(%player)   // when someone logs in after the mission has been set
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIloggedIn != 1)
    {
      %ready = 0;
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    if(%waitingFor != 1) %plural = "s.";
     else %plural = ".";

    say(0, 0, getName(%player) @ " has logged in.  Waiting for " @ %waitingFor @ " more player" @ %plural );
  }
  else
  {
    say(0, 0, "All players logged in.");
    Mercs::launchMission();
  }
}


function Mercs::startCheck3(%player)   // when someone quits the server after the mission is set
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIloggedIn != 1)
    {
      %ready = 0;
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    if(%waitingFor != 1) %plural = "s.";
     else %plural = ".";

    say(0, 0, getName(%player) @ " has quit.  Waiting for " @ %waitingFor @ " more player" @ %plural );
  }
  else
  {
    say(0, 0, getName(%player) @ " has quit.  All players are now logged in.");
    Mercs::launchMission();
  }
}


function Mercs::statRoll(%number, %sides)
{
  %total = 0;
  for(%i=0; %i<%number; %i++)
  {
    %die = randomInt(1, %sides);
    %total = %total + %die;
  }
  %average = %total / %number;
  %final = %average / ((%sides+1)/2);
  return(%final);
}


function Mercs::swapMissions(%a, %b)
{
  %MissionA = $MImission[%a];
  %BountyPercentA = $MImissionBountyPercent[%a];
  %DateA = $MImissionDate[%a];
  %DifficultyA = $MImissionDifficulty[%a];
  %LocationA = $MImissionLocation[%a];
  %PayA = $MImissionPay[%a];
  %TimeA = $MImissionTime[%a];
  %TransportPercentA = $MImissionTransportPercent[%a];
  %TypeA = $MImissionType[%a];
  %ParametersA = $MImissionParameters[%a];
  for(%i=0; %i<%ParametersA; %i++)
  {
    %ParameterA[%i] = $MImissionParameter[%a, %i];
  }

  %MissionB = $MImission[%b];
  %BountyPercentB = $MImissionBountyPercent[%b];
  %DateB = $MImissionDate[%b];
  %DifficultyB = $MImissionDifficulty[%b];
  %LocationB = $MImissionLocation[%b];
  %PayB = $MImissionPay[%b];
  %TimeB = $MImissionTime[%b];
  %TransportPercentB = $MImissionTransportPercent[%b];
  %TypeB = $MImissionType[%b];
  %ParametersB = $MImissionParameters[%b];
  for(%i=0; %i<%ParametersB; %i++)
  {
    %ParameterB[%i] = $MImissionParameter[%b, %i];
  }

  $MImission[%a] = %MissionB;
  $MImissionBountyPercent[%a] = %BountyPercentB;
  $MImissionDate[%a] = %DateB;
  $MImissionDifficulty[%a] = %DifficultyB;
  $MImissionLocation[%a] = %LocationB;
  $MImissionPay[%a] = %PayB;
  $MImissionTime[%a] = %TimeB;
  $MImissionTransportPercent[%a] = %TransportPercentB;
  $MImissionType[%a] = %TypeB;
  $MImissionParameters[%a] = %ParametersB;
  for(%i=0; %i<%ParametersB; %i++)
  {
    $MImissionParameter[%a, %i] = %ParameterB[%i];
  }

  $MImission[%b] = %MissionA;
  $MImissionBountyPercent[%b] = %BountyPercentA;
  $MImissionDate[%b] = %DateA;
  $MImissionDifficulty[%b] = %DifficultyA;
  $MImissionLocation[%b] = %LocationA;
  $MImissionPay[%b] = %PayA;
  $MImissionTime[%b] = %TimeA;
  $MImissionTransportPercent[%b] = %TransportPercentA;
  $MImissionType[%b] = %TypeA;
  $MImissionParameters[%b] = %ParametersA;
  for(%i=0; %i<%ParametersA; %i++)
  {
    $MImissionParameter[%b, %i] = %ParameterA[%i];
  }
}


//================================

function remoteMercs::Login(%player, %password)
{
  if(%player.MIloggedIn == 1) say(%player, 0, "You are already logged in, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");
   else Mercs::checkPlayerName(%player, %password);
}


function remoteMercs::abortMission(%player)
{
}


function remoteMercs::Drone(%player, %slotNum)
{
  if(%slotNum == "All") return; 
  if(%slotNum > $server::droneSlots) say(%player, 0, "This server only allows up to " @ $server::droneSlots @ " per player.");
  Mercs::buyDrone(%player, %slotNum);
}


function remoteMercs::statusReport(%player)
{
  if(%player.MILoggedIn == 0) return;
  say(%player, 0, "Hello, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");
  %netWorth = %player.MImoney;
  for(%j=0; %j<%player.MIdrones; %j++)
  {
    if(%player.MIdroneDescription[%j] == "") say(%player, 0, "Drone " @ %j @ " -- (empty)");
    else say(%player, 0, "Drone " @ %j @ " -- " @ %player.MIdroneDescription[%j] @ " (" @ %player.MIdroneBioderm[%j] @ ") -- $" @ %player.MIdroneCost[%j]);
    %netWorth = %netWorth + %player.MIdroneCost[%j];
  }
  say(%player, 0, "Net worth: $" @ %netWorth);
}

//================================



function missionSelect::structure::OnScan(%scannee, %scanner, %string)
{
  if($MIreadyToLaunch == 2) return;
  Mercs::selectNextMission();
}


function missionSelect::structure::OnAttacked(%target, %attacker)
{
  if($MIreadyToLaunch == 2) return;
  %player = playerManager::vehicleIdToPlayerNum(%attacker);

  if(%player.MIloggedIn == 0)
  {
    say(%player, 0, "Please log in before selecting a mission.");
    return;
  }

  if($MIcurrentMission < 0)
  {
    say(%player, 0, "Please select a mission by scanning the structure first.");
    return;
  }

  if($MIreadyToLaunch == 1)
  {
    Mercs::launchMission();
    return;
  }
  else if($MIreadyToLaunch == 0)
  {
    $MIreadyToLaunch = 1;
    Mercs::startCheck(%player);
  }
}


//======================


function Mercs::round(%number)
{
  %roundNum = %number;
  if(%number > 0)
  {
    %excess = (%number - floor(%number));
    if(%excess >= 0.5)
    {
      %roundNum = (floor(%number) + 1);
    }
    else
    {
      %roundNum = floor(%number);
    }
  }
  if(%number < 0)
  {
    %excess = (floor(%number) - %number);
    if(%excess <= 0.5)
    {
      %roundNum = floor(%number);
    }
    else
    {
      %roundNum = (floor(%number) - 1);
    }
  }
  return %roundNum;
}


//=========================


function moneyRankings::structure::onScan(%scanned, %scanner)
{
  for(%i=1; %i<$MIPlayers; %i++)
  {
    %moneyPlayer[%i] = $MIPlayer[%i];
    %money[%i] = $MIPlayerMoney[%i];
    for(%j=0; %j<$MIPlayerDrones; %j++)
    {
      %droneCost = $MIPlayerDroneCost[%i, %j];
      %money[%i] = %money[%i] + %droneCost;
    }
  }

  %check = 1;
  while(%check == 1)
  {
    %check = 0;
    for(%i=2; %i<$MIPlayers; %i++)
    {
      if(%money[%i] > %money[%i-1])
      {
        %temp1 = %moneyPlayer[%i];
        %temp2 = %moneyPlayer[%i-1];
        %temp1b = %money[%i];
        %temp2b = %money[%i-1];
        %moneyPlayer[%i] = %temp2;
        %moneyPlayer[%i-1] = %temp1;
        %money[%i] = %temp2b;
        %money[%i-1] = %temp1b;
        %check = 1;
      }
    }
  }

  %player = playerManager::vehicleIDToPlayerNum(%scanner);
  %rank = 5;
  for(%i=5; %i>0; %i--)
  {
    if(%moneyPlayer[%i] != "") say(%player, 0, %i @ ": " @ %moneyPlayer[%i] @ " ($" @ %money[%i] @ ")");
  }
}


function lobbyTransport::structure::onScan(%scanned, %scanner)
{
  if($MIreadyToLaunch == 2) return;

  exec("MercsIncLobbyList.cs");

  if(%scanned.lobby == "") %scanned.lobby = 0;  
   else %scanned.lobby++;
  if(%scanned.lobby >= %lobbies) %scanned.lobby = 0;
  if(%lobby[%scanned.lobby] == $MICurrentLobby) %scanned.lobby++;
  if(%scanned.lobby >= %lobbies) %scanned.lobby = 0;

  $MissionCycling::Stage0 = %lobby[%scanned.lobby];
  %player = playerManager::vehicleIDToPlayerNum(%scanner);
  say(%player, 0, %description[%scanned.lobby]);
}

function lobbyTransport::structure::onAttacked(%target, %attacker)
{
  exec("MercsIncLobbyList.cs");

  if($MIreadyToLaunch == 2) return;
  %player = playerManager::vehicleIDToPlayerNum(%attacker);
  if(%target.lobby == "")
  {
    say(%player, 0, "Please scan the transport node to select a new base.");
    return;
  }
  $MIreadyToLaunch = 2;
  say(0, 0, "Transport departing for " @ %name[%target.lobby] @ " in 5 seconds.");
  schedule("missionEndConditionMet();", 5);
}


//==================================== Functions for building up a squad


function Mercs::buyDrone(%player, %slotNum)
{
  if(%player.MILoggedIn == 0)
  {
    say(%player, 0, "Please log in before buying a drone");
    return;
  }
  if($MIdronefarm.counter < 0)
  {
    say(%player, 0, "Please scan the building to select a drone first");
    return;
  }

  Mercs::addMoney(%player, %player.MIdroneCost[%slotNum]);      // refund the cost of the old drone
  if(%player.MIdroneFile[%slotNum] == "") %player.MIdrones++;
  $MIPlayerDrones[%player.MIid] = %player.MIdrones;
  %player.MIdroneFile[%slotNum] = $MIDronefarm.currentVehicleFile;
  %player.MIdroneDescription[%slotNum] = $MIDronefarm.currentVehicleDescription;
  %player.MIdroneCost[%slotNum] = $MIDronefarm.currentVehicleCost;
  %player.MIdroneBioderm[%slotNum] = $MIBioderm.currentDerm;
  Mercs::addMoney(%player, ($MIDronefarm.currentVehicleCost) * -1);
  say(%player, 0, "Vehicle added to slot #" @ %slotNum @ ".  Your new account is $" @ %player.MIMoney );
  Mercs::confirmDrones(%player);
}


function Mercs::forfeitDrone(%player, %slotNum)
{
  if(%player.MILoggedIn == 0)
  {
    say(%player, 0, "Please log in first");
    return;
  }
  if(%player.MIdroneFile[%slotNum] == "")
  {
    say(%player, 0, "No drone in selected slot");
    return;
  }

  say(%player, 0, "Refunding $" @ %player.MIdroneCost[%slotNum] @ " to your account.  Your account is now $" @ %player.MImoney);
  Mercs::addMoney(%player, %player.MIdroneCost[%slotNum]);      // refund the cost of the old drone
  Mercs::orderDrones(%player);
}


function Mercs::nextDrone(%player)
{
  exec("MIPCList.cs");
  $MIDronefarm.counter++;
  if($MIDronefarm.counter >= %PCVehicleCount) $MIDronefarm.counter = 0;
  if($MIdronefarm.showroomModel != "") deleteObject($MIdronefarm.showroomModel);
  $MIdronefarm.currentVehicleFile = %PCVehicleFile[$MIDronefarm.counter];
  $MIdronefarm.currentVehicleDescription = %PCVehicleProfile[$MIDronefarm.counter];
  $MIdronefarm.showroomModel = loadObject("AIVehicle", $MIdronefarm.currentVehicleFile);
  setTeam($MIdronefarm.showroomModel, *IDSTR_TEAM_RED);
  setVehicleRadarVisible( $MIdronefarm.showroomModel, False );
  order($MIdronefarm.showroomModel, shutdown, true);
  warp($MIdronefarm.showroomModel, getObjectID("MissionGroup\\padmarker"));
  $MIdronefarm.currentVehicleCost = Mercs::round((MIConfigCosts::checkvalue($MIdronefarm.showroomModel) + 500) * $MIbioderm.multiplier);
  say(%player, 0, "Model " @ $MIDronefarm.counter + 1 @ "/" @ %PCVehicleCount @ " -- " @ $MIdronefarm.currentVehicleDescription @ ", $" @ (MIConfigCosts::checkvalue($MIdronefarm.showroomModel) + 500) @
    " x" @ $MIbioderm.multiplier @ " = $" @ $MIdronefarm.currentVehicleCost);
}


function Mercs::nextBioderm(%player)
{
  if(%player.MILoggedIn == 0) say(%player, 0, "Please log in before selecting a pilot");

  $MIbioderm.counter++;
  if($MIbioderm.counter > 2) $MIbioderm.counter = 0;
  if($MIbioderm.counter == 0)
  {
    $MIbioderm.multiplier = 0.5;
    $MIbioderm.currentDerm = "L1 Bioderm"; 
    if($MIdronefarm.counter >= 0) $MIdronefarm.currentVehicleCost = Mercs::round((MIConfigCosts::checkvalue($MIdronefarm.showroomModel) + 500) * $MIbioderm.multiplier);
    say(%player, 0, "Level 1 bioderm (0.5x price)");
  }
  if($MIbioderm.counter == 1)
  {
    $MIbioderm.multiplier = 10;
    $MIbioderm.currentDerm = "L5 Bioderm"; 
    if($MIdronefarm.counter >= 0) $MIdronefarm.currentVehicleCost = Mercs::round((MIConfigCosts::checkvalue($MIdronefarm.showroomModel) + 500) * $MIbioderm.multiplier);
    say(%player, 0, "Level 5 bioderm (5x price)");
  }
  if($MIbioderm.counter == 2)
  {
    $MIbioderm.multiplier = 20;
    $MIbioderm.currentDerm = "L10 Bioderm"; 
    if($MIdronefarm.counter >= 0) $MIdronefarm.currentVehicleCost = Mercs::round((MIConfigCosts::checkvalue($MIdronefarm.showroomModel) + 500) * $MIbioderm.multiplier);
    say(%player, 0, "Level 10 bioderm (20x price)");
  }
}


function dronefarm::structure::OnScan(%scannee, %scanner, %string)
{
  %player = playerManager::vehicleIDToPlayerNum(%scanner);
  Mercs::nextDrone(%player);
}


function bioderms::structure::OnScan(%scannee, %scanner, %string)
{
  %player = playerManager::vehicleIDToPlayerNum(%scanner);
  Mercs::nextBioderm(%player);
}


function vehicle::OnScan(%scannee, %scanner, %string)
{
  %player = playerManager::vehicleIDToPlayerNum(%scanner);
  if(%scannee != $MIdronefarm.showroomModel) return;
  say(%player, 0, $MIdronefarm.currentVehicleDescription @ ", $" @ MIConfigCosts::checkvalue($MIdronefarm.showroomModel) @
   " x" @ $MIbioderm.multiplier @ " = $" @ $MIdronefarm.currentVehicleCost);
}


function cloneadrone::trigger::onEnter(%trigger, %vehicleId)
{
  %player = playerManager::vehicleIDToPlayerNum(%vehicleID);
  PlayerClone::copyVehicle(%player);
}


//============================


function Mercs::AttackOrder()
{
}

function Mercs::FormOrder()
{
}

function Mercs::GuardOrder()
{
}

function Mercs::HoldfireOrder()
{
}

function Mercs::HoldpositionOrder()
{
}

function Mercs::ShutdownOrder()
{
}

